#ifndef __LCD22_H__
#define __LCD22_H__

#include "stm32f2xx.h"
#include "stm32f2xx_gpio.h"
#include "stm32f2xx_spi.h"
#include "MX1081_IO.H"
//#include "User_systick.h"
#include "AsciiLib.h"


#define LCD_RS_H()		GPIO_SetBits(LCD_RS_PORT,LCD_RS_PIN);
#define LCD_RS_L()		GPIO_ResetBits(LCD_RS_PORT,LCD_RS_PIN);

#define LCD_CS_H()		GPIO_SetBits(LCD_SPI_CS_PORT,LCD_SPI_CS_PIN);
#define LCD_CS_L()		GPIO_ResetBits(LCD_SPI_CS_PORT,LCD_SPI_CS_PIN);

#define TOUCH_nCS_H() GPIO_SetBits(Touch_SPI_CS_PORT,Touch_SPI_CS_PIN);
#define TOUCH_nCS_L() GPIO_ResetBits(Touch_SPI_CS_PORT,Touch_SPI_CS_PIN);

// #define  MAX_X  240
// #define  MAX_Y  320 

#define DISP_ORIENTATION					0
//#define DISP_ORIENTATION					90
//#define DISP_ORIENTATION					180
//#define DISP_ORIENTATION					270


/* Private define ------------------------------------------------------------*/

#if  ( DISP_ORIENTATION == 90 ) || ( DISP_ORIENTATION == 270 )

#define  MAX_X  320	
#define  MAX_Y  240   

#elif  ( DISP_ORIENTATION == 0 ) || ( DISP_ORIENTATION == 180 )

#define  MAX_X  240	
#define  MAX_Y  320 

#endif







/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Grey           0xF7DE
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

#define RGB565CONVERT(red, green, blue) (int) (((red >> 3) << 11) | ((green >> 2) << 5) | (blue >> 3))

/* Private function prototypes -----------------------------------------------*/
void LCD_Initializtion(void);
void LCD_Clear(uint16_t Color);	
//void LCD_SetBacklight(uint8_t intensity);
uint16_t LCD_GetPoint(uint16_t Xpos,uint16_t Ypos);
void LCD_SetPoint(uint16_t Xpos,uint16_t Ypos,uint16_t point);
void PutChar(uint16_t Xpos,uint16_t Ypos,uint8_t c,uint16_t charColor,uint16_t bkColor);
void LCD_DrawLine( uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1 , uint16_t color );
void PutChinese(uint16_t Xpos,uint16_t Ypos,uint8_t *str,uint16_t Color,uint16_t bkColor); 
void GUI_Text(uint16_t Xpos, uint16_t Ypos, uint8_t *str,uint16_t Color, uint16_t bkColor);
void GUI_Chinese(uint16_t Xpos, uint16_t Ypos, uint8_t *str,uint16_t Color, uint16_t bkColor);	
void LCD_DrawPicture(uint16_t StartX,uint16_t StartY,uint16_t EndX,uint16_t EndY,uint16_t *pic);
void LCD_Drawcircle(int x0, int y0, int r, int color);

__inline void LCD_WriteIndex(uint16_t index);
__inline void LCD_WriteData(uint16_t data);
__inline uint16_t LCD_ReadData(void);
__inline uint16_t LCD_ReadReg(uint16_t LCD_Reg);
__inline void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_RegValue);
static void LCD_SetCursor( uint16_t Xpos, uint16_t Ypos );

#endif 
