#include "stdio.h"
#include "ctype.h"

#include "stm32f2xx.h"
#include "platform.h"
#include "mxchipWNET.h"

#define LowPowerMode
#define AP_NAME           "WaveshareNet"
#define AP_PASSWORD       "waveshare0755"

u8 wifiModeSwitch = 0;
u8 softAPStarted = 0;
u8 startScan = 0;
network_InitTypeDef_st wNetConfig;

/* ========================================
	User provide callback functions 
    ======================================== */
void RptConfigmodeRslt(network_InitTypeDef_st *nwkpara)
{
}
		
void userWatchDog(void)
{
}

void WifiStatusHandler(int event)
{
  switch (event) {
    case MXCHIP_WIFI_UP:
      printf("Wi-Fi up \r\n");
			if( wifiModeSwitch == 0)
				wifiModeSwitch = 1;
      break;
    case MXCHIP_WIFI_DOWN:
      printf("Station down \r\n");
      break;
    default:
      break;
  }
  return;
}

void ApListCallback(UwtPara_str *pApList)
{
	int i;
  printf("Find %d APs: \r\n", pApList->ApNum);
  for (i=0;i<pApList->ApNum;i++)
    printf("    SSID: %s, Signal: %d%%\r\n", pApList->ApList[i].ssid, pApList->ApList[i].ApPower);
	startScan = 0;
}

void NetCallback(net_para_st *pnet)
{
	printf("IP address: %s \r\n", pnet->ip);
	printf("NetMask address: %s \r\n", pnet->mask);
	printf("Gateway address: %s \r\n", pnet->gate);
	printf("DNS server address: %s \r\n", pnet->dns);
  printf("MAC address: %s \r\n", pnet->mac);
}

void stationModeStart(void)
{
	memset(&wNetConfig, 0x0, sizeof(network_InitTypeDef_st));
	
	wNetConfig.wifi_mode = Station;
	strcpy((char*)wNetConfig.wifi_ssid, AP_NAME);
	strcpy((char*)wNetConfig.wifi_key, AP_PASSWORD);
	wNetConfig.dhcpMode = DHCP_Client;
	StartNetwork(&wNetConfig);
	printf("connect to %s.....\r\n", wNetConfig.wifi_ssid);
}

void softAPModeStart(void)
{
  memset(&wNetConfig, 0x0, sizeof(network_InitTypeDef_st));
	
	wNetConfig.wifi_mode = Soft_AP;
  strcpy((char*)wNetConfig.wifi_ssid, "uAP");
  strcpy((char*)wNetConfig.wifi_key, "");
	strcpy((char*)wNetConfig.local_ip_addr, "192.168.0.1");
	strcpy((char*)wNetConfig.address_pool_start, "192.168.0.10");
	strcpy((char*)wNetConfig.address_pool_end, "192.168.0.177");
	wNetConfig.dhcpMode = DHCP_Server;
	StartNetwork(&wNetConfig);
	printf("Setup soft AP: %s\r\n", wNetConfig.wifi_ssid);
}

int main(void)
{
  mxchipInit();
  UART_Init();

  printf("\r\nStart scan\r\n");
	mxchipStartScan();
	startScan = 1;
  stationModeStart();
	

  while(1){
    mxchipTick();
    if(wifiModeSwitch==1&&softAPStarted==0){
      softAPModeStart();
			softAPStarted = 1;
    }
  }
}


void Button_irq_handler(void *arg)
{
	if(startScan == 0){
		startScan = 1;
		printf("Start scanning by user...\r\n");
		mxchipStartScan();		
	}
	else
		printf("A scanning is pending...\r\n");
	
}




