#include "stdio.h"
#include "ctype.h"

#include "platform.h"
#include "mxchipWNET.h"
#include "menu.h"

network_InitTypeDef_st wNetConfig;
int configSuccess = 0;
int menu_enable = 1;
const char menu[] =
   "\n"
   "+***************(C) COPYRIGHT 2013 MXCHIP corporation************+\n"
   "|          EMW316x WPS and EasyLink configuration demo           |\n"
   "+ command ----------------+ function ----_-----------------------+\n"
   "| 1:WPS                   | WiFi Protected Setup                 |\n"
   "| 2:EasyLink              | One step configuration from MXCHIP   |\n"
   "| 3:REBOOT                | Reboot                               |\n"
   "| ?:HELP                  | displays this help                   |\n"
   "+-------------------------+--------------------------------------+\n"
   "|                           By William Xu from MXCHIP M2M Team   |\n"
   "+----------------------------------------------------------------+\n";

void print_msg(void);

/* ========================================
	User provide callback functions 
    ======================================== */
void RptConfigmodeRslt(network_InitTypeDef_st *nwkpara)
{
	if(nwkpara == NULL){
		printf("Configuration failed\r\n");
		printf ("\nMXCHIP> ");
		menu_enable = 1;
	}
	else{
		configSuccess = 1;
		memcpy(&wNetConfig, nwkpara, sizeof(network_InitTypeDef_st));
		printf("Configuration is successful, SSID:%s, Key:%s\r\n", \
																		wNetConfig.wifi_ssid,\
																		wNetConfig.wifi_key);
	}
}
		
void userWatchDog(void)
{
}

void WifiStatusHandler(int event)
{
  switch (event) {
    case MXCHIP_WIFI_UP:
      printf("Station up \r\n");
		  printf ("\nMXCHIP> ");
			menu_enable = 1;
      break;
    case MXCHIP_WIFI_DOWN:
      printf("Station down \r\n");
      break;
    default:
      break;
  }
  return;
}

void ApListCallback(UwtPara_str *pApList)
{
}

void NetCallback(net_para_st *pnet)
{
	printf("IP address: %s \r\n", pnet->ip);
	printf("NetMask address: %s \r\n", pnet->mask);
	printf("Gateway address: %s \r\n", pnet->gate);
	printf("DNS server address: %s \r\n", pnet->dns);
  printf("MAC address: %s \r\n", pnet->mac);
}

int main(void)
{
  mxchipInit();
	UART_Init();
	printf(menu);
	printf ("\nMXCHIP> ");
	
	
  while(1) {
    mxchipTick();	
		if(menu_enable)
			Main_Menu();
		if(configSuccess){
			wNetConfig.wifi_mode = Station;
			wNetConfig.dhcpMode = DHCP_Client;
			StartNetwork(&wNetConfig);
			printf("connect to %s.....\r\n", wNetConfig.wifi_ssid);
			configSuccess = 0;
			printf ("\nMXCHIP> ");
			menu_enable = 1;
		}
	}
}

