#include "function.h"
#include "http_process.h"
#include "mxchipWNet.h"
#include "main.h"


#define HTTP_DATA_MAX_LEN 2048
#define UDP_SEARCH_MAX_LEN 100

typedef struct
{
	char *pToken1;	//HTTP request 
	char *pToken2;	//URL
	char *pToken3;  //URL function
//	char *pToken4;	//Next
} httpToken_struct;

typedef enum{
	HTTP_DISPLAY_STANDARD,
	HTTP_DISPLAY_IOS,
	HTTP_DISPLAY_ANDROID
} httpDisplayType;

char httpRequest[HTTP_DATA_MAX_LEN];
extern EAbox_st	*EAbox;
static void HandleHttpClient(int index);
static u8 HTTPParse(char* pStr, httpToken_struct *httpToken);
static void send_http_data(int index, char *data, int len);

extern int MS_TIMER;

void http_init(void)
{
	EAbox->httpServer_fd = 0;
}

void stop_http_server(void)
{
	int i;
	EAbox->httpServer_fd = 0;
	for(i=0;i<MAX_CLIENT;i++) {
			if (EAbox->httpClient_fd[i] != 0){
				close(EAbox->httpClient_fd[i]);
				EAbox->httpClient_fd[i] = 0;
		}
	}
	close(EAbox->httpServer_fd);
	EAbox->httpServer_fd = 0;
	
}

void http_tick(void)
{
	int i, j, len;
	fd_set readfds;
	struct timeval_t t;
	struct sockaddr_t addr;
	socklen_t addrLen;
	int optval = 1000;
	char udpSearch[UDP_SEARCH_MAX_LEN];
	
	
	FD_ZERO(&readfds);
	t.tv_sec = 0;
	t.tv_usec = 1000;
	
	if (EAbox->httpServer_fd==0) {
		EAbox->httpServer_fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

		addr.s_port = 80;
		bind(EAbox->httpServer_fd, &addr, sizeof(addr));
		listen(EAbox->httpServer_fd, 0);
		
		memset(EAbox->httpClient_fd, 0, 4 * MAX_CLIENT);
	} else {
		FD_SET(EAbox->httpServer_fd, &readfds);
		for(i=0;i<MAX_CLIENT;i++) {
			if (EAbox->httpClient_fd[i] != 0)
				FD_SET(EAbox->httpClient_fd[i], &readfds);
		}
	}
	
	if (EAbox->udpSearch_fd==0) {
		  EAbox->udpSearch_fd = socket(AF_INET, SOCK_DGRM, IPPROTO_UDP);
      addr.s_port = 8090;
      bind(EAbox->udpSearch_fd, &addr, sizeof(addr));
      _printf("Open UDP port %d\r\n", addr.s_port);
	} else {
		FD_SET(EAbox->udpSearch_fd, &readfds);
	}

	select(1, &readfds, NULL, NULL, &t);

	for(i=0;i<MAX_CLIENT;i++) {
		if (EAbox->httpClient_fd[i] != 0) {
			if (FD_ISSET(EAbox->httpClient_fd[i], &readfds)) {
				HandleHttpClient(EAbox->httpClient_fd[i]);
				msleep(50);
        close(EAbox->httpClient_fd[i]);
	      EAbox->httpClient_fd[i] = 0;
			}
		}
	}
	
	if (FD_ISSET(EAbox->httpServer_fd, &readfds)) {
		j = accept(EAbox->httpServer_fd, &addr, &len);
		if (j > 0) {
			for(i=0;i<MAX_CLIENT;i++) {
				if ( EAbox->httpClient_fd[i] == 0) {
					 EAbox->httpClient_fd[i] = j;
					setsockopt(j, 0, SO_SNDTIMEO, &optval, 4);
					break;
				}
			}
		}
	}

	if (FD_ISSET(EAbox->udpSearch_fd, &readfds)) {
		_printf("Recved a UDP search package!");
		recvfrom(EAbox->udpSearch_fd, udpSearch, UDP_SEARCH_MAX_LEN, 0, &addr, &addrLen);
		if(strcmp(udpSearch, "hello")==0)
			sendto(EAbox->udpSearch_fd, udpSearch, strlen(udpSearch), 0, &addr, sizeof(struct sockaddr_t));
	}	

}


/*******************************************************************************
* Function Name  	:  HandleHttpClient.  
* Description    	:  handle http request.
* Input          		:  ClientSocket:Http Client socket.
* Return         	:  None.
*******************************************************************************/
static void HandleHttpClient(int index)
{
	int NumOfBytes;
	httpToken_struct httpToken ={0,0,0};

	msleep(200); // sleep 200 ms, just incase http request fregment.
	
	NumOfBytes = recv(index, httpRequest, HTTP_DATA_MAX_LEN, 0);
	if (NumOfBytes < 0)
		{
			return;
		}
	else if (NumOfBytes == 0)
		{
			return;
		}

	httpRequest[NumOfBytes] = '\0';			// ַβ־;

//////////////////// 20130729  http request ǰ
	
	if(!HTTPParse(httpRequest,&httpToken)) 	//http request header error
		goto EXIT;							

#if 0			///// ҳȨ޴;
	p_auth = strstr(httpToken.pToken2, auth_str);	//
	if (p_auth == NULL)
		{ // un-authrized
        		send_http_data(index, (char*)authrized, strlen(authrized));
        		goto EXIT;
		}
	else
		{
        		p_auth += strlen(auth_str);
        		if (*p_auth != 0x0d)
				{
            				send_http_data(index, (char*)authrized, strlen(authrized));
            				goto EXIT;
        			}
    		}
	#endif
		
	if(!strcmp(httpToken.pToken1, "GET"))  
	{
		if(!strncmp(httpToken.pToken2,"/EABox",strlen("/EABox")))
		{

		}
	}
	else if(!strcmp(httpToken.pToken1, "POST"))  
	{
		if(!strncmp(httpToken.pToken2,"/EABox",strlen("/EABox")))
			{
				_printf("Processing a local EABox message...\r\n");
				GetPhonePost(index,(unsigned char *)httpToken.pToken2);
				DealWithCMD(&RevPhonePacketCmd);
				send_http_data(index, httpRequest, strlen(httpRequest));
			}
	}
EXIT:
    
	return;
}

static u8 HTTPParse(char* pStr, httpToken_struct *httpToken)
{
	char* pch = strchr(pStr, ' ');
	char* pch2 = strchr(pStr, '/');
	char* pch3;
	httpToken->pToken1 = pStr;
	
	if(pch) 
	{
		*pch='\0';		// һ" " ΪpToken1
		
		pch++;
		pch3 = strchr(pch, ' ');				////////////////////////////
		if(pch2&&pch2<pch3)
			{//ӵһ'/' ĵһ' '  pToken2 ('/' ڸֵַ)
				httpToken->pToken2=pch2;
				pch2++;			
				pch2 = strchr(pch2, '/');
				if(pch2&&pch2<pch3)
					{// pToken2 еһ'/' βpToken3
						 pch2++;
						httpToken->pToken3=pch2;
					}
				else
					httpToken->pToken3=NULL;
			}
		else
			httpToken->pToken2=NULL;
		return TRUE;
	}
	return FALSE;
}

static void send_http_data(int index, char *data, int len)
{
	int SendCount = 0, NumAtOnce;
	u32 end_time = MS_TIMER+5000; // max wait for 5 seconds.
	
	while(SendCount < len)
	{
		NumAtOnce = send(index, data+SendCount, len-SendCount, 0); 
		if(0 >= NumAtOnce)
			{
				return;
			}
		if (end_time<MS_TIMER) // timeout
			return;
		SendCount+=NumAtOnce;
	}	  
}
