#ifndef _MX1081_IO_H
#define _MX1081_IO_H



#include "stm32f2xx.h"
#include "stm32f2xx_spi.h"

//#define USE_USART1            USART1
 #define USE_USART2            USART2
// #define USE_UART4             UART4


#if defined (USE_USART1)



	#define USARTx_IRQn           USART1_IRQn
	#define USE_USARTx	              USART1
	#define USARTx_IRQHandler     USART1_IRQHandler
	#define USARTx_CLK          	RCC_APB2Periph_USART1
	#define USARTx_CLK_INIT		    RCC_APB2PeriphClockCmd

	#define USARTx_RX_PIN         GPIO_Pin_10
	#define USARTx_RX_SOURCE      GPIO_PinSource10
	#define USARTx_RX_GPIO_PORT   GPIOA
	#define USARTx_RX_GPIO_CLK    RCC_AHB1Periph_GPIOA
	#define USARTx_RX_AF          GPIO_AF_USART1

	#define USARTx_TX_PIN         GPIO_Pin_9
	#define USARTx_TX_SOURCE      GPIO_PinSource9
	#define USARTx_TX_GPIO_PORT   GPIOA
	#define USARTx_TX_GPIO_CLK    RCC_AHB1Periph_GPIOA
	#define USARTx_TX_AF          GPIO_AF_USART1

#elif  defined (USE_USART2)
/* Definition for USARTx resources **********************************************/

	#define USARTx_IRQn           USART2_IRQn
	#define USE_USARTx	          USART2
	#define USARTx_IRQHandler     USART2_IRQHandler

	#define USARTx_CLK          	RCC_APB1Periph_USART2
	#define USARTx_CLK_INIT		    RCC_APB1PeriphClockCmd

	#define USARTx_RX_PIN         GPIO_Pin_3
	#define USARTx_RX_SOURCE      GPIO_PinSource3
	#define USARTx_RX_GPIO_PORT   GPIOA
	#define USARTx_RX_GPIO_CLK    RCC_AHB1Periph_GPIOA
	#define USARTx_RX_AF          GPIO_AF_USART2

	#define USARTx_TX_PIN         GPIO_Pin_2
	#define USARTx_TX_SOURCE      GPIO_PinSource2
	#define USARTx_TX_GPIO_PORT   GPIOA
	#define USARTx_TX_GPIO_CLK    RCC_AHB1Periph_GPIOA
	#define USARTx_TX_AF          GPIO_AF_USART2

	#define USARTx_CTS_PIN        GPIO_Pin_0
	#define USARTx_CTS_SOURCE     GPIO_PinSource0
	#define USARTx_CTS_GPIO_PORT  GPIOA
	#define USARTx_CTS_GPIO_CLK   RCC_AHB1Periph_GPIOA
	#define USARTx_CTS_AF         GPIO_AF_USART2

	#define USARTx_RTS_PIN        GPIO_Pin_1
	#define USARTx_RTS_SOURCE     GPIO_PinSource1
	#define USARTx_RTS_GPIO_PORT  GPIOA
	#define USARTx_RTS_GPIO_CLK   RCC_AHB1Periph_GPIOA
	#define USARTx_RTS_AF         GPIO_AF_USART2

#elif  defined (USE_UART4)


	#define USARTx_IRQn           UART4_IRQn
	#define USE_USARTx	              UART4

	#define USARTx_IRQHandler     UART4_IRQHandler
	#define USARTx_CLK          	RCC_APB1Periph_UART4
	#define USARTx_CLK_INIT		    RCC_APB1PeriphClockCmd

	#define USARTx_RX_PIN         GPIO_Pin_1
	#define USARTx_RX_SOURCE      GPIO_PinSource1
	#define USARTx_RX_GPIO_PORT   GPIOA
	#define USARTx_RX_GPIO_CLK    RCC_AHB1Periph_GPIOA
	#define USARTx_RX_AF          GPIO_AF_UART4

	#define USARTx_TX_PIN         GPIO_Pin_0
	#define USARTx_TX_SOURCE      GPIO_PinSource0
	#define USARTx_TX_GPIO_PORT   GPIOA
	#define USARTx_TX_GPIO_CLK    RCC_AHB1Periph_GPIOA
	#define USARTx_TX_AF          GPIO_AF_UART4
#endif


#define  USE_I2C1   I2C1
//#define  USE_I2C2   I2C2

#if defined (USE_I2C1)

	#define USE_I2Cx                USE_I2C1    

	#define USE_I2Cx_CLK          	RCC_APB1Periph_I2C1
	#define USE_I2Cx_INIT		        RCC_APB1PeriphClockCmd
	

	#define USE_I2Cx_SDA_PIN         GPIO_Pin_7
	#define USE_I2Cx_SDA_SOURCE      GPIO_PinSource7
	#define USE_I2Cx_SDA_PORT        GPIOB
	#define USE_I2Cx_SDA_CLK    		 RCC_AHB1Periph_GPIOB
	#define USE_I2Cx_SDA_AF          GPIO_AF_I2C1

	#define USE_I2Cx_SCL_PIN         GPIO_Pin_6
	#define USE_I2Cx_SCL_SOURCE      GPIO_PinSource6
	#define USE_I2Cx_SCL_PORT        GPIOB
	#define USE_I2Cx_SCL_CLK         RCC_AHB1Periph_GPIOB
	#define USE_I2Cx_SCL_AF          GPIO_AF_I2C1

#elif  defined (USE_I2C2)

	#define USE_I2Cx                USE_I2C2    
	#define USE_I2Cx_CLK          	RCC_APB1Periph_I2C2
	#define USE_I2Cx_INIT		        RCC_APB1PeriphClockCmd
	

	#define USE_I2Cx_SDA_PIN         GPIO_Pin_0
	#define USE_I2Cx_SDA_SOURCE      GPIO_PinSource0
	#define USE_I2Cx_SDA_PORT        GPIOF
	#define USE_I2Cx_SDA_CLK    		 RCC_AHB1Periph_GPIOF
	#define USE_I2Cx_SDA_AF          GPIO_AF_I2C2

	#define USE_I2Cx_SCL_PIN         GPIO_Pin_1
	#define USE_I2Cx_SCL_SOURCE      GPIO_PinSource1
	#define USE_I2Cx_SCL_PORT        GPIOF
	#define USE_I2Cx_SCL_CLK         RCC_AHB1Periph_GPIOF
	#define USE_I2Cx_SCL_AF          GPIO_AF_I2C2

#endif


#define USE_SPI1                  SPI1
//#define USE_SPI2                  SPI2

#if defined (USE_SPI1)
	#define USE_SPIx                	USE_SPI1    
	#define USE_SPIx_CLK          		RCC_APB2Periph_SPI1
	#define USE_SPIx_INIT		       	  RCC_APB2PeriphClockCmd
	#define USE_SPIx_AF          			GPIO_AF_SPI1
	
	
	#define USE_SPIx_MOSI_PIN         GPIO_Pin_7
	#define USE_SPIx_MOSI_SOURCE      GPIO_PinSource7
	#define USE_SPIx_MOSI_PORT        GPIOA
	#define USE_SPIx_MOSI_CLK         RCC_AHB1Periph_GPIOA

	
	#define USE_SPIx_MISO_PIN         GPIO_Pin_6
	#define USE_SPIx_MISO_SOURCE      GPIO_PinSource6
	#define USE_SPIx_MISO_PORT        GPIOA
	#define USE_SPIx_MISO_CLK    		  RCC_AHB1Periph_GPIOA


	#define USE_SPIx_SCK_PIN          GPIO_Pin_5
	#define USE_SPIx_SCK_SOURCE       GPIO_PinSource5
	#define USE_SPIx_SCK_PORT         GPIOA
	#define USE_SPIx_SCK_CLK          RCC_AHB1Periph_GPIOA
	
	#define USE_SPIx_SSN_PIN         GPIO_Pin_4
	#define USE_SPIx_SSN_SOURCE      GPIO_PinSource4
	#define USE_SPIx_SSN_PORT        GPIOA
	#define USE_SPIx_SSN_CLK         RCC_AHB1Periph_GPIOA
	
	
	
#elif defined (USE_SPI2)

	#define USE_SPIx                	USE_SPI2
	#define USE_SPIx_CLK          		RCC_APB1Periph_SPI2
	#define USE_SPIx_INIT		       	  RCC_APB1PeriphClockCmd
	#define USE_SPIx_AF          			GPIO_AF_SPI2
	
	
	#define USE_SPIx_MOSI_PIN         GPIO_Pin_3
	#define USE_SPIx_MOSI_SOURCE      GPIO_PinSource3
	#define USE_SPIx_MOSI_PORT        GPIOI
	#define USE_SPIx_MOSI_CLK         RCC_AHB1Periph_GPIOI

	
	#define USE_SPIx_MISO_PIN         GPIO_Pin_2
	#define USE_SPIx_MISO_SOURCE      GPIO_PinSource2
	#define USE_SPIx_MISO_PORT        GPIOI
	#define USE_SPIx_MISO_CLK    		  RCC_AHB1Periph_GPIOI


	#define USE_SPIx_SCK_PIN          GPIO_Pin_1
	#define USE_SPIx_SCK_SOURCE       GPIO_PinSource1
	#define USE_SPIx_SCK_PORT         GPIOI
	#define USE_SPIx_SCK_CLK          RCC_AHB1Periph_GPIOI
	
	#define USE_SPIx_SSN_PIN         GPIO_Pin_0
	#define USE_SPIx_SSN_SOURCE      GPIO_PinSource0
	#define USE_SPIx_SSN_PORT        GPIOI
	#define USE_SPIx_SSN_CLK         RCC_AHB1Periph_GPIOI
	
#endif 

/*******************SPI SDCard *****************/

	#define USE_SDCard_SPIx           SPI1    
	#define USE_SDCard_CLK          		RCC_APB2Periph_SPI1
	#define USE_SDCard_INIT		       	  RCC_APB2PeriphClockCmd
	#define USE_SDCard_AF          			GPIO_AF_SPI1
	
	
	#define USE_SDCard_MOSI_PIN         GPIO_Pin_7
	#define USE_SDCard_MOSI_SOURCE      GPIO_PinSource7
	#define USE_SDCard_MOSI_PORT        GPIOA
	#define USE_SDCard_MOSI_CLK         RCC_AHB1Periph_GPIOA

	
	#define USE_SDCard_MISO_PIN         GPIO_Pin_6
	#define USE_SDCard_MISO_SOURCE      GPIO_PinSource6
	#define USE_SDCard_MISO_PORT        GPIOA
	#define USE_SDCard_MISO_CLK    		  RCC_AHB1Periph_GPIOA


	#define USE_SDCard_SCK_PIN          GPIO_Pin_5
	#define USE_SDCard_SCK_SOURCE       GPIO_PinSource5
	#define USE_SDCard_SCK_PORT         GPIOA
	#define USE_SDCard_SCK_CLK          RCC_AHB1Periph_GPIOA
	
	#define USE_SDCard_SSN_PIN         GPIO_Pin_4
	#define USE_SDCard_SSN_SOURCE      GPIO_PinSource4
	#define USE_SDCard_SSN_PORT        GPIOA
	#define USE_SDCard_SSN_CLK         RCC_AHB1Periph_GPIOA

/******************   UDA1380  **********************/
#define USE_UDA1380_I2C1             		 I2C1

#define USE_UDA1380_I2Cx          				USE_UDA1380_I2C1
#define USE_UDA1380_I2Cx_CLK          		RCC_APB1Periph_I2C1
#define USE_UDA1380_I2Cx_INIT		       	  RCC_APB1PeriphClockCmd
#define USE_UDA1380_I2Cx_AF          			GPIO_AF_I2C1


#define USE_UDA1380_I2Cx_SDA_PIN          GPIO_Pin_7
#define USE_UDA1380_I2Cx_SDA_SOURCE       GPIO_PinSource7
#define USE_UDA1380_I2Cx_SDA_PORT         GPIOB
#define USE_UDA1380_I2Cx_SDA_CLK          RCC_AHB1Periph_GPIOB


#define USE_UDA1380_I2Cx_SCL_PIN          GPIO_Pin_6
#define USE_UDA1380_I2Cx_SCL_SOURCE       GPIO_PinSource6
#define USE_UDA1380_I2Cx_SCL_PORT         GPIOB
#define USE_UDA1380_I2Cx_SCL_CLK          RCC_AHB1Periph_GPIOB


#define USE_UDA1380_I2S2             		  SPI2

#define USE_UDA1380_I2Sx_ADDRESS          0x4000380C

#define USE_UDA1380_I2Sx          				USE_UDA1380_I2S2
#define USE_UDA1380_I2Sx_CLK          		RCC_APB1Periph_SPI2
#define USE_UDA1380_I2Sx_INIT		       	  RCC_AHB1PeriphClockCmd
#define USE_UDA1380_I2Sx_AF          			GPIO_AF_SPI2

#define USE_UDA1380_I2Sx_SCK_PIN          GPIO_Pin_10
#define USE_UDA1380_I2Sx_SCK_SOURCE       GPIO_PinSource10
#define USE_UDA1380_I2Sx_SCK_PORT         GPIOB
#define USE_UDA1380_I2Sx_SCK_CLK          RCC_AHB1Periph_GPIOB

#define USE_UDA1380_I2Sx_WS_PIN           GPIO_Pin_12
#define USE_UDA1380_I2Sx_WS_SOURCE        GPIO_PinSource12
#define USE_UDA1380_I2Sx_WS_PORT          GPIOB
#define USE_UDA1380_I2Sx_WS_CLK           RCC_AHB1Periph_GPIOB

#define USE_UDA1380_I2Sx_SD_PIN           GPIO_Pin_3
#define USE_UDA1380_I2Sx_SD_SOURCE        GPIO_PinSource3
#define USE_UDA1380_I2Sx_SD_PORT          GPIOI
#define USE_UDA1380_I2Sx_SD_CLK           RCC_AHB1Periph_GPIOI




/************************CAN********************/
#define USE_CAN1                  CAN1

#define USE_CANx                	USE_CAN1
#define USE_CANx_CLK          		RCC_APB1Periph_CAN1
#define USE_CANx_INIT		       	  RCC_APB1PeriphClockCmd
#define USE_CANx_AF          			GPIO_AF_CAN1


#define USE_CANx_TXD_PIN         GPIO_Pin_1
#define USE_CANx_TXD_SOURCE      GPIO_PinSource1
#define USE_CANx_TXD_PORT        GPIOD
#define USE_CANx_TXD_CLK         RCC_AHB1Periph_GPIOD


#define USE_CANx_RXD_PIN         GPIO_Pin_0
#define USE_CANx_RXD_SOURCE      GPIO_PinSource0
#define USE_CANx_RXD_PORT        GPIOD
#define USE_CANx_RXD_CLK    		 RCC_AHB1Periph_GPIOD





/*****************KEY JOYSTICK**************/



#define GPIO_WAKEUP_CLK    RCC_AHB1Periph_GPIOA
#define GPIO_WAKEUP_PORT   GPIOA
#define GPIO_WAKEUP_PIN    GPIO_Pin_0

#define GPIO_USER1_CLK    RCC_AHB1Periph_GPIOD
#define GPIO_USER1_PORT   GPIOD
#define GPIO_USER1_PIN    GPIO_Pin_1

#define GPIO_USER2_CLK    RCC_AHB1Periph_GPIOD
#define GPIO_USER2_PORT   GPIOD
#define GPIO_USER2_PIN    GPIO_Pin_5

#define GPIO_JOY_A_CLK    RCC_AHB1Periph_GPIOD
#define GPIO_JOY_A_PORT   GPIOD
#define GPIO_JOY_A_PIN    GPIO_Pin_6

#define GPIO_JOY_B_CLK    RCC_AHB1Periph_GPIOH
#define GPIO_JOY_B_PORT   GPIOH
#define GPIO_JOY_B_PIN    GPIO_Pin_13

#define GPIO_JOY_C_CLK    RCC_AHB1Periph_GPIOH
#define GPIO_JOY_C_PORT   GPIOH
#define GPIO_JOY_C_PIN    GPIO_Pin_15

#define GPIO_JOY_D_CLK    RCC_AHB1Periph_GPIOI
#define GPIO_JOY_D_PORT   GPIOI
#define GPIO_JOY_D_PIN    GPIO_Pin_2

#define GPIO_JOY_PRESS_CLK    RCC_AHB1Periph_GPIOI
#define GPIO_JOY_PRESS_PORT   GPIOI
#define GPIO_JOY_PRESS_PIN    GPIO_Pin_0

/******************LED**********************/
#define GPIO_LED1_CLK    RCC_AHB1Periph_GPIOB
#define GPIO_LED1_PORT   GPIOB
#define GPIO_LED1_PIN    GPIO_Pin_4

#define GPIO_LED2_CLK    RCC_AHB1Periph_GPIOB
#define GPIO_LED2_PORT   GPIOB
#define GPIO_LED2_PIN    GPIO_Pin_3

#define GPIO_LED3_CLK    RCC_AHB1Periph_GPIOA
#define GPIO_LED3_PORT   GPIOA
#define GPIO_LED3_PIN    GPIO_Pin_15

#define GPIO_LED4_CLK    RCC_AHB1Periph_GPIOF
#define GPIO_LED4_PORT   GPIOF
#define GPIO_LED4_PIN    GPIO_Pin_9

// #define GPIO_LED1_CLK    RCC_AHB1Periph_GPIOI
// #define GPIO_LED1_PORT   GPIOI
// #define GPIO_LED1_PIN    GPIO_Pin_0

// #define GPIO_LED2_CLK    RCC_AHB1Periph_GPIOI
// #define GPIO_LED2_PORT   GPIOI
// #define GPIO_LED2_PIN    GPIO_Pin_1

// #define GPIO_LED3_CLK    RCC_AHB1Periph_GPIOI
// #define GPIO_LED3_PORT   GPIOI
// #define GPIO_LED3_PIN    GPIO_Pin_2

// #define GPIO_LED4_CLK    RCC_AHB1Periph_GPIOI
// #define GPIO_LED4_PORT   GPIOI
// #define GPIO_LED4_PIN    GPIO_Pin_3
/******************LCD**********************/
#define LCD_RS_CLK            RCC_AHB1Periph_GPIOH
#define LCD_RS_PORT           GPIOH
#define LCD_RS_PIN            GPIO_Pin_15

#define LCD_SPI_CS_CLK        RCC_AHB1Periph_GPIOE
#define LCD_SPI_CS_PORT       GPIOE
#define LCD_SPI_CS_PIN        GPIO_Pin_5

#define LCD_SPI_SCK_CLK       RCC_AHB1Periph_GPIOA
#define LCD_SPI_SCK_SOURCE    GPIO_PinSource5
#define LCD_SPI_SCK_AF        GPIO_AF_SPI1
#define LCD_SPI_SCK_PORT      GPIOA
#define LCD_SPI_SCK_PIN       GPIO_Pin_5

#define LCD_SPI_MOSI_CLK       RCC_AHB1Periph_GPIOA
#define LCD_SPI_MOSI_SOURCE    GPIO_PinSource7
#define LCD_SPI_MOSI_AF        GPIO_AF_SPI1
#define LCD_SPI_MOSI_PORT      GPIOA
#define LCD_SPI_MOSI_PIN       GPIO_Pin_7

#define LCD_SPI_MISO_CLK       RCC_AHB1Periph_GPIOA
#define LCD_SPI_MISO_SOURCE    GPIO_PinSource6
#define LCD_SPI_MISO_AF        GPIO_AF_SPI1
#define LCD_SPI_MISO_PORT      GPIOA
#define LCD_SPI_MISO_PIN       GPIO_Pin_6

/******************TouchPanel**********************/
#define Touch_SPI_CS_CLK       RCC_AHB1Periph_GPIOA
#define Touch_SPI_CS_PORT      GPIOA
#define Touch_SPI_CS_PIN       GPIO_Pin_9

#define Touch_IRQ_CLK          RCC_AHB1Periph_GPIOA
#define Touch_IRQ_PORT         GPIOA
#define Touch_IRQ_PIN          GPIO_Pin_10

/*******************OV7670 SCCB***************************/
 /* Configure I2C1 pins: PB10->SIOC and PB11->SIOD */ 
#define OV7670_SCCB                        	I2C2
#define OV7670_SCCB_CLK                    	RCC_APB1Periph_I2C2

#define OV7670_SCCB_SDA_PIN                 	GPIO_Pin_10
#define OV7670_SCCB_SDA_GPIO_PORT           	GPIOB
#define OV7670_SCCB_SDA_GPIO_CLK            	RCC_AHB1Periph_GPIOB
#define OV7670_SCCB_SDA_SOURCE              	GPIO_PinSource10
#define OV7670_SCCB_SDA_AF                  	GPIO_AF_I2C2

#define OV7670_SCCB_SCL_PIN                 	GPIO_Pin_11
#define OV7670_SCCB_SCL_GPIO_PORT           	GPIOB
#define OV7670_SCCB_SCL_GPIO_CLK            	RCC_AHB1Periph_GPIOB
#define OV7670_SCCB_SCL_SOURCE              	GPIO_PinSource11
#define OV7670_SCCB_SCL_AF                  	GPIO_AF_I2C2

uint8_t Read_JOYState(void);
void Led_Toggle(uint8_t keyvulua);
void GPIO_JOYSTICK_KEY_Configuration(void);
void GPIO_LED_Configuration(void);
void GPIO_LED_Binky(uint32_t xMS);
void Delay(__IO uint32_t nCount);

#endif   /*_MX1081_IO_H*/
