#include "MX1081_IO.H"
#include "stm32f2xx.h"
#include "mxchipWNET.h"
/**
  * @brief  Delay Function.
  * @param  nCount:specifies the Delay time length.
  * @retval None
  */
void Delay(__IO uint32_t nCount)
{
  while(nCount--)
  {
  }
}

void GPIO_JOYSTICK_KEY_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_AHB1PeriphClockCmd(GPIO_WAKEUP_CLK | GPIO_USER1_CLK | GPIO_USER2_CLK | GPIO_JOY_A_CLK | GPIO_JOY_B_CLK | GPIO_JOY_C_CLK | GPIO_JOY_D_CLK | GPIO_JOY_PRESS_CLK, ENABLE);
	
	/* Configure Input pushpull mode */
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_WAKEUP_PIN;
	GPIO_Init(GPIO_WAKEUP_PORT, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_USER1_PIN;
	GPIO_Init(GPIO_USER1_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_USER2_PIN;
	GPIO_Init(GPIO_USER2_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_JOY_A_PIN;
	GPIO_Init(GPIO_JOY_A_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_JOY_B_PIN;
	GPIO_Init(GPIO_JOY_B_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_JOY_C_PIN;
	GPIO_Init(GPIO_JOY_C_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_JOY_D_PIN;
	GPIO_Init(GPIO_JOY_D_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_JOY_PRESS_PIN;
	GPIO_Init(GPIO_JOY_PRESS_PORT, &GPIO_InitStructure);
		
}


void GPIO_LED_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_AHB1PeriphClockCmd(GPIO_LED1_CLK | GPIO_LED1_CLK | GPIO_LED2_CLK | GPIO_LED3_CLK, ENABLE);
	
	/* Configure PF6 PF7 PF8 PF9 in output pushpull mode */	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_LED1_PIN;
	GPIO_Init(GPIO_LED1_PORT, &GPIO_InitStructure);	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_LED2_PIN;
	GPIO_Init(GPIO_LED2_PORT, &GPIO_InitStructure);	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_LED3_PIN;
	GPIO_Init(GPIO_LED3_PORT, &GPIO_InitStructure);	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_LED4_PIN;
	GPIO_Init(GPIO_LED4_PORT, &GPIO_InitStructure);		

	GPIO_ResetBits(GPIO_LED1_PORT,GPIO_LED1_PIN);
	GPIO_ResetBits(GPIO_LED2_PORT,GPIO_LED2_PIN);
	GPIO_ResetBits(GPIO_LED3_PORT,GPIO_LED3_PIN);
	GPIO_ResetBits(GPIO_LED4_PORT,GPIO_LED4_PIN);
}


void GPIO_LED_Binky(uint32_t xMS)
{
	GPIO_SetBits(GPIO_LED1_PORT,GPIO_LED1_PIN);
	GPIO_SetBits(GPIO_LED2_PORT,GPIO_LED2_PIN);
	GPIO_SetBits(GPIO_LED3_PORT,GPIO_LED3_PIN);
	GPIO_SetBits(GPIO_LED4_PORT,GPIO_LED4_PIN);
	msleep(xMS);   
	GPIO_ResetBits(GPIO_LED1_PORT,GPIO_LED1_PIN);
	GPIO_ResetBits(GPIO_LED2_PORT,GPIO_LED2_PIN);
	GPIO_ResetBits(GPIO_LED3_PORT,GPIO_LED3_PIN);
	GPIO_ResetBits(GPIO_LED4_PORT,GPIO_LED4_PIN);	
	msleep(xMS);   
}
 
uint8_t Read_JOYState(void)
{
	if(!GPIO_ReadInputDataBit(GPIO_WAKEUP_PORT,GPIO_WAKEUP_PIN))
		return 0;
	else if(!GPIO_ReadInputDataBit(GPIO_USER1_PORT,GPIO_USER1_PIN))
		return 1;
	else if(!GPIO_ReadInputDataBit(GPIO_USER2_PORT,GPIO_USER2_PIN))
		return 2;
	else if(!GPIO_ReadInputDataBit(GPIO_JOY_A_PORT,GPIO_JOY_A_PIN))
		return 3;
	else if(!GPIO_ReadInputDataBit(GPIO_JOY_B_PORT,GPIO_JOY_B_PIN))
		return 4;
	else if(!GPIO_ReadInputDataBit(GPIO_JOY_C_PORT,GPIO_JOY_C_PIN))
		return 5;
	else if(!GPIO_ReadInputDataBit(GPIO_JOY_D_PORT,GPIO_JOY_D_PIN))
		return 6;
	else if(!GPIO_ReadInputDataBit(GPIO_JOY_PRESS_PORT,GPIO_JOY_PRESS_PIN))
		return 7;	
	else 
		return 8;	
}

void Led_Toggle(uint8_t keyvulua)
{
	switch(keyvulua)
		{
	
			case 0:
				GPIO_SetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				
				GPIO_SetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				
				GPIO_SetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				
				GPIO_SetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				break;
			case 1:
				GPIO_SetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				
				GPIO_SetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				
				GPIO_SetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				
				GPIO_SetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				break;
			case 2 :
				GPIO_SetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				GPIO_SetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				GPIO_SetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				GPIO_SetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				GPIO_ResetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				GPIO_ResetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				GPIO_ResetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);		
				break;
					
			case 3:
				GPIO_SetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				msleep(10);
				GPIO_ResetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				msleep(100);
				break;
			case 4:
				GPIO_SetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				msleep(100);
				break;
			case 5:
			  	GPIO_SetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
			  	msleep(100);
			  	GPIO_ResetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
			  	msleep(100);
				break;
			case 6:
				GPIO_SetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				break;
			case 7:
				GPIO_SetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				GPIO_SetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				GPIO_SetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				GPIO_SetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				GPIO_ResetBits(GPIO_LED1_PORT , GPIO_LED1_PIN);
				GPIO_ResetBits(GPIO_LED2_PORT , GPIO_LED2_PIN);
				GPIO_ResetBits(GPIO_LED3_PORT , GPIO_LED3_PIN);
				GPIO_ResetBits(GPIO_LED4_PORT , GPIO_LED4_PIN);
				msleep(100);
				break;
			
			case 8:
	
				break;
		}
}
