#ifndef __TOUCHPANEL_H__
#define __TOUCHPANEL_H__

#include "stm32f2xx.h"
#include "MX1081_IO.H"
#include "LCD22.h"


#define TOUCH_nCS_H()		GPIO_SetBits(Touch_SPI_CS_PORT,Touch_SPI_CS_PIN);
#define TOUCH_nCS_L()		GPIO_ResetBits(Touch_SPI_CS_PORT,Touch_SPI_CS_PIN);

#define TP_INT_IN       GPIO_ReadInputDataBit(Touch_IRQ_PORT,Touch_IRQ_PIN)

//typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;


/* Private typedef -----------------------------------------------------------*/
typedef	struct POINT 
{
   uint16_t x;
   uint16_t y;
}Coordinate;


typedef struct Matrix 
{						
long double An,  
            Bn,     
            Cn,   
            Dn,    
            En,    
            Fn,     
            Divider ;
} Matrix ;

/* Private variables ---------------------------------------------------------*/
extern Coordinate ScreenSample[3];
extern Coordinate DisplaySample[3];
extern Matrix matrix ;
extern Coordinate  display ;

/* Private define ------------------------------------------------------------*/

#define	CHX 	0x90
#define	CHY 	0xd0
void TP_GetAdXY(int *x,int *y) ;
Coordinate *Read_Ads7846(void);
void TouchPanel_Calibrate(uint16_t charColor, uint16_t bkColor );
void DrawCross(uint16_t Xpos,uint16_t Ypos,int color);
void TP_DrawPoint(uint16_t Xpos,uint16_t Ypos,int color);
FunctionalState SetCalibrationMatrix( Coordinate * displayPtr,Coordinate * screenPtr,Matrix * matrixPtr);
FunctionalState GetDisplayPoint(Coordinate * displayPtr,Coordinate * screenPtr,Matrix * matrixPtr );
void TouchPanel_Calibrate2(void);
void Color_Box( uint16_t Xpos,uint16_t Ypos, uint16_t X_Width, uint16_t Y_Width,uint16_t bkColor, uint16_t Stroke_Color );
#endif 

