#include "stdio.h"
#include "ctype.h"

#include "MX1081_IO.H"
#include "stm32f2xx.h"
#include "platform.h"
#include "mxchipWNET.h"
#include "SPI_MSD_Driver.h"
#include "diskio.h"
#include "ff.h"

/* Private functions ---------------------------------------------------------*/
FATFS fs;            // Work area (file system object) for logical drive
FIL fsrc, fdst;      // file objects
FRESULT res;         // FatFs function common result code
UINT br, bw;         // File R/W count


/* buffer size (in byte) for R/W operations */
#define BUFFER_SIZE     4096   
unsigned char buffer1[100] = "This is a new file, the data is just written in!  һļҲµ!";

static BYTE buffer[BUFFER_SIZE] ;		/* Working buffer */

#if _USE_LFN
char Fs_LongFileName[_MAX_LFN * (_DF1S ? 2 : 1) + 1];
#endif

void pintf_State_information(FRESULT inf)
{
   switch (inf)
   {
   	case FR_OK:
		printf("(0) Succeeded \r\n");
		break;
   	case FR_DISK_ERR:
		printf("(1) A hard error occured in the low level disk I/O layer\r\n");
		break;
	case FR_INT_ERR:
		printf("(2) Assertion failed\r\n");
		break;
	case FR_NOT_READY:
	 	printf("(3) The physical drive cannot work\r\n");
        break;
    case FR_NO_FILE:
	 	printf("(4) Could not find the file \r\n");
        break;
    case FR_NO_PATH:
	 	printf("(5) Could not find the path\r\n");
        break;
    case FR_INVALID_NAME:
	 	printf("(6) The path name format is invalid \r\n");
        break;
    case FR_DENIED:
	 	printf("(7) Acces denied due to prohibited access or directory full\r\n");
        break;
    case FR_EXIST:
	 	printf("(8) Acces denied due to prohibited access\r\n");
        break;
    case FR_INVALID_OBJECT:
	 	printf("(9) The file/directory object is invalid\r\n");
        break;
    case FR_WRITE_PROTECTED:
	 	printf("(10) The physical drive is write protected\r\n");
        break;
    case FR_INVALID_DRIVE:
	 	printf("(11) The logical drive number is invalid\r\n");
        break;
    case FR_NOT_ENABLED:
	 	printf("(12) The volume has no work area \r\n");
        break;
    case FR_NO_FILESYSTEM:
	 	printf("(13) There is no valid FAT volume on the physical drive\r\n");
        break;
    case FR_MKFS_ABORTED:
	 	printf("The f_mkfs() aborted due to any parameter error\r\n");
        break;
    case FR_TIMEOUT:
	 	printf("(15) Could not get a grant to access the volume within defined period\r\n");
        break;
    case FR_LOCKED:
	 	printf("(16) The operation is rejected according to the file shareing policy\r\n");
        break;
    case FR_NOT_ENOUGH_CORE:
	 	printf("(17) LFN working buffer could not be allocated\r\n");
        break;
    case FR_TOO_MANY_OPEN_FILES:
	 	printf("(18) Number of open files > _FS_SHARE\r\n");
        break;
    default:
		break;
	}    
}




void FatFs_Test(void)
{ 
	unsigned int a;
	FRESULT res;
	FILINFO finfo;
	DIR dirs;
	static FIL File1, File2, File3;		/* File objects */
	
	char path[16]={""};  
#if _USE_LFN
    finfo.lfname = Fs_LongFileName;
    finfo.lfsize = sizeof(Fs_LongFileName);
#endif

	printf("SD Card Initialization:%d\r\n",disk_initialize(0));
	printf("Mounting SD Card:%d\r\n",f_mount(0, &fs));

	if (f_opendir(&dirs, path) == FR_OK) 
	{
    	while (f_readdir(&dirs, &finfo) == FR_OK)  
    	{
      		if (finfo.fattrib & AM_ARC) 
      		{
        		if(!finfo.fname[0]) break;        
        		printf("Short File Name: %s\r\n",finfo.fname);
#if _USE_LFN
        		printf("Long File Name: %s\r\n",finfo.lfname);
#endif   
            
			}
		} 
	}
	
	
	



/*½һnew.txtļ*/
   printf(">:new 'new.txt'file !\r\n\t");
   res = f_open(&File2, "new.txt", FA_CREATE_ALWAYS);
   pintf_State_information(res);
   f_close(&File2); //Ǵ򿪣½ļһǵùر

/*дһļ*/
    printf(">:New 'Text'Docment,And to write data file!\r\n\t");
    res = f_open(&File3, "NewText.txt", FA_WRITE | FA_CREATE_ALWAYS); 
    pintf_State_information(res);
    if (res == FR_OK) 
    { 
        res = f_write(&File3, buffer1, 100,&bw);
        pintf_State_information(res);  

    } 
    f_close(&File3);      //  رļ f_open ɶԳ 
	
/*һTXTļ*/
	res = f_open(&File1, "NewText.txt", FA_READ); 
	if(!res) 
	{ 
		printf("open test.txt: %d\r\n",res); 
		br=1; 
		a=0; 
		printf("File content:\r\n\t"); 
		for (;;) 
		{ 
			for(a=0; a<512; a++) buffer[a]=0; 
			res = f_read(&File1, buffer, sizeof(buffer), &br); 
			printf("%s\r\n",buffer); 
			if (res || br < sizeof(buffer)) break;  // error or eof 
		} 
	} 
    printf("\r\n");
	f_close(&File1); //Ǵ򿪣½ļһǵùر
	
}


int main(void)
{
	UART_Init();
	USART_NVIC_Config();
// 	mxchipInit(); 
	printf("\r\nWelcome to WaveShare STM32F2 series MCU Board Open1081\r\n");
	
	MSD_SPI_Configuration();
	
	FatFs_Test();

	while(1);

}
